/*
 * File         : Choleski_s.C
 * Author       : Guansong Zhang
 * Created      : Fri Feb 20 16:36:16 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */


#include "math.h"
#include "adlib.h"

const int n = 1024 ;
float a [n][n], b [n];

int main(int argc, char** argv) {

    int i, j, k, s;

    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	if (j>=i)
	  a[i][j]=i+1;
	else
	  a[i][j]=j+1;
      }
    }

    AdlibClock(0);

    a[0][0]=sqrt(a[0][0]);

    /* This is for column major
    for (k=0; k<n-1; k++) {
      for (s=k+1; s<n; s++) {
	a[s][k]/=a[k][k];
      }

      for (j=k+1; j<n; j++) {
	for (i=j; i<n; i++) {
	  a[i][j]-=a[i][k]*a[j][k];
	}
      }

      a[k+1][k+1]=(float)Math.sqrt(a[k+1][k+1]);

    }
    */

    // reverse i, j for row major.

    for (k=0; k<n-1; k++) {
      for (s=k+1; s<n; s++) {
	a[k][s]/=a[k][k];
      }

      for (j=k+1; j<n; j++) {
	for (i=j; i<n; i++) {
	  a[j][i]-=a[k][i]*a[k][i];
	}
      }

      a[k+1][k+1]=sqrt(a[k+1][k+1]);

    }

    AdlibClock(1);

    /*
    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	printf("%f ",a[i][j]);
      };
    
      printf("\n");
    }

    */
}
